/*
    soundcore.c - sound core routines (output, ipol, mixing, ...)
    Copyright (C) 2007  Ch. Klippel <ck@mamalala.net>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "irq.h"
#include "soundirq.h"
#include "sound.h"
#include "lpc2220.h"

#define AUTO_OFF_TIME	0x4000

/*
extern volatile unsigned int tval;
extern volatile unsigned char bl_val, cmp_val;
extern volatile unsigned int slen;
extern volatile unsigned char *sdata;
extern volatile unsigned char sact;
extern volatile char out1;
extern volatile char last_sample;
*/

unsigned int tval;
unsigned char bl_val, cmp_val;
unsigned int slen;
unsigned char *sdata;
unsigned char sact;
unsigned char out1;
unsigned char last_sample;

void __attribute__ ((section(".text.fastcode"))) soundIRQ (void)
{
	PWMIR = 0x01;
	if(sact != 0)
	{
		out1++;
		if(out1 == 2)		// quik & dirty anti-aliasing filter
		{			// (2 point linear interpolated 2x upsampling)
			
			PWMMR2 = (sdata[tval] + last_sample) >> 1;
			PWMLER = 0x04;
		}
		else
		if(out1 == 4)	// prepare next sample
		{
			out1 = 0;
			last_sample = sdata[tval];
			PWMMR2 = last_sample;
			tval++;
			if(tval >= slen)
			{
				tval = 0;
				FIOCLR0 = (1<<11);
				sact = 0;
				PWMPR = 7;
			}
			PWMLER = 0x04;
		}
	}

	cmp_val++;
	cmp_val &= 0x3F;

	if(bl_val > cmp_val)
		FIOCLR0 |= (1<<4);
	else
		FIOSET0 |= (1<<4);
}
